package net.wanji.opt.dao.mapper.strategy;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import net.wanji.opt.entity.strategy.StrategyParameterConfig;
import net.wanji.opt.entity.strategy.StrategyPriorityConfig;
import net.wanji.opt.entity.strategy.StrategyPriorityDailyInfo;
import net.wanji.opt.synthesis.pojo.StrategyFactoryEntity;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface StrategyPriorityMapper extends BaseMapper<StrategyPriorityDailyInfo> {

    /**
     * 查询表t_strategy_priority_daily_info所有信息
     */
    List<StrategyPriorityDailyInfo> findAllStrategyPriorityDailyInfo();

    /**
     * 根据主键id查询表t_strategy_priority_daily_info信息
     *
     * @param id
     */
    StrategyPriorityDailyInfo findStrategyPriorityDailyInfoByid(@Param("id") Long id);

    /**
     * 根据条件查询表t_strategy_priority_daily_info信息
     *
     * @param strategyPriorityDailyInfo
     */
    List<StrategyPriorityDailyInfo> findStrategyPriorityDailyInfoByCondition(StrategyPriorityDailyInfo strategyPriorityDailyInfo);

    /**
     * 根据主键id查询表t_strategy_priority_daily_info信息
     *
     * @param id
     */
    Integer deleteStrategyPriorityDailyInfoByid(@Param("id") Long id);

    /**
     * 根据主键id更新表t_strategy_priority_daily_info信息
     *
     * @param strategyPriorityDailyInfo
     */
    Integer updateStrategyPriorityDailyInfoByid(StrategyPriorityDailyInfo strategyPriorityDailyInfo);

    /**
     * 新增表t_strategy_priority_daily_info信息
     *
     * @param strategyPriorityDailyInfo
     */
    Integer addStrategyPriorityDailyInfo(StrategyPriorityDailyInfo strategyPriorityDailyInfo);


    List<StrategyPriorityDailyInfo> pageStrategyCrossList();


    List<StrategyFactoryEntity> getStrategyList();

    List<StrategyFactoryEntity> getSceneList(Integer type);

    List<StrategyFactoryEntity> getCompanyList();


    void savePriorityInsert(List<StrategyPriorityConfig> saveList);


    List<StrategyPriorityConfig> selectPriorityTable(String crossId);

    void deletePriorityConfig(String crossId);


    List<String> getstrategyNo(@Param("crossId") String crossId, @Param("type") Integer type);

    List<StrategyFactoryEntity> getPriorityConfigData(@Param("strategyNo") List<String> strategyNo, @Param("crossId") String crossId, @Param("type") Integer type);

    void savePlanConfig(@Param("savePlanList") List<StrategyPriorityDailyInfo> savePlanList);

    List<StrategyPriorityDailyInfo> selectPlanTable(String crossId);

    void deletePlanConfig(String crossId);


    List<StrategyPriorityDailyInfo> getPlanConfigData(@Param("crossId") String crossId, @Param("type") Integer type);

    List<StrategyParameterConfig> paramterConfigTable(String crossId);


    void deleteParamterConfig(String crossId);

    void saveParamConfig(@Param("savePlanList") List<StrategyParameterConfig> savePlanList);

    List<StrategyParameterConfig> getParamConfigData(@Param("crossId") String crossId, @Param("type") Integer type, @Param("strategyNo") String strategyNo);

    List<StrategyPriorityDailyInfo> getStrategyGreenWave();

    List<StrategyPriorityConfig> selectGreenPriorityTable(Integer greenId);

    void deleteGreenPriorityConfig(Integer greenId);

    List<String> getGreenstrategyNo(@Param("greenId") Integer greenId, @Param("type") Integer type);

    List<StrategyFactoryEntity> getGreenPriorityConfigData(@Param("strategyNo") List<String> strategyNo, @Param("greenId") Integer greenId, @Param("type") Integer type);

    List<StrategyPriorityDailyInfo> selectGreenPlanTable(Integer greenId);

    void deleteGreenPlanConfig(Integer greenId);

    List<StrategyPriorityDailyInfo> getGreenPlanConfigData(@Param("greenId") Integer greenId, @Param("type") Integer type);

    List<StrategyParameterConfig> paramterGreenConfigTable(Integer greenId);

    void deleteGreenParamterConfig(Integer greenId);

    List<StrategyParameterConfig> getGreenParamConfigData(@Param("greenId") Integer greenId, @Param("type") Integer type, @Param("strategyNo") String strategyNo);

    /**
     * 通过路口编号或干线编号，分组编号查询策略库详情
     * @param crossId
     * @param greenId
     * @param groupId
     * @return
     */
    List<StrategyFactoryEntity> selectCrossGroupStrategyList(@Param("crossId") String crossId, @Param("greenId") Integer greenId, @Param("groupId") Integer groupId);


    /**
     * 删除路口编号分组下策略编号
     * @param crossId
     * @param greenId
     * @param groupId
     * @param strategyNo
     * @return
     */
    void deleteCrossGreenPriorityConfig(@Param("crossId") String crossId, @Param("greenId") Integer greenId,
                                   @Param("groupId") Integer groupId, @Param("strategyNo") String strategyNo);

    /**
     * 通过路口编号或干线编号，分组编号，查询优先级配置日计划详情
     * @param crossId
     * @param greenId
     * @param groupId
     * @return
     */
    List<StrategyPriorityDailyInfo> selectCrossGreenGroupDailyPlanList(@Param("crossId") String crossId, @Param("greenId") Integer greenId, @Param("groupId") Integer groupId);

    /**
     * 通过路口编号或干线编号，分组编号查询策略优先级配置详情
     * @param crossId
     * @param greenId
     * @param groupId
     * @return
     */
    List<StrategyPriorityConfig> selectCrossGroupStrategyPriorityList(@Param("crossId") String crossId, @Param("greenId") Integer greenId, @Param("groupId") Integer groupId);

}

